/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// to - The sip uri represnting the destination of the call.    timeout - The time in milliseconds to wait for the completion of the transfer.    disconnect - If true, disconnect the call after transfer is completed.
    /// </summary>
    [DataContract]
        public partial class BlindTransferParams :  IEquatable<BlindTransferParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BlindTransferParams" /> class.
        /// </summary>
        /// <param name="to">to.</param>
        /// <param name="sipHeaders">sipHeaders.</param>
        /// <param name="timeout">timeout.</param>
        /// <param name="disconnect">disconnect.</param>
        public BlindTransferParams(string to = default(string), List<string> sipHeaders = default(List<string>), int? timeout = default(int?), bool? disconnect = default(bool?))
        {
            this.To = to;
            this.SipHeaders = sipHeaders;
            this.Timeout = timeout;
            this.Disconnect = disconnect;
        }
        
        /// <summary>
        /// Gets or Sets To
        /// </summary>
        [DataMember(Name="to", EmitDefaultValue=false)]
        public string To { get; set; }

        /// <summary>
        /// Gets or Sets SipHeaders
        /// </summary>
        [DataMember(Name="sipHeaders", EmitDefaultValue=false)]
        public List<string> SipHeaders { get; set; }

        /// <summary>
        /// Gets or Sets Timeout
        /// </summary>
        [DataMember(Name="timeout", EmitDefaultValue=false)]
        public int? Timeout { get; set; }

        /// <summary>
        /// Gets or Sets Disconnect
        /// </summary>
        [DataMember(Name="disconnect", EmitDefaultValue=false)]
        public bool? Disconnect { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class BlindTransferParams {\n");
            sb.Append("  To: ").Append(To).Append("\n");
            sb.Append("  SipHeaders: ").Append(SipHeaders).Append("\n");
            sb.Append("  Timeout: ").Append(Timeout).Append("\n");
            sb.Append("  Disconnect: ").Append(Disconnect).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as BlindTransferParams);
        }

        /// <summary>
        /// Returns true if BlindTransferParams instances are equal
        /// </summary>
        /// <param name="input">Instance of BlindTransferParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(BlindTransferParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.To == input.To ||
                    (this.To != null &&
                    this.To.Equals(input.To))
                ) && 
                (
                    this.SipHeaders == input.SipHeaders ||
                    this.SipHeaders != null &&
                    input.SipHeaders != null &&
                    this.SipHeaders.SequenceEqual(input.SipHeaders)
                ) && 
                (
                    this.Timeout == input.Timeout ||
                    (this.Timeout != null &&
                    this.Timeout.Equals(input.Timeout))
                ) && 
                (
                    this.Disconnect == input.Disconnect ||
                    (this.Disconnect != null &&
                    this.Disconnect.Equals(input.Disconnect))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.To != null)
                    hashCode = hashCode * 59 + this.To.GetHashCode();
                if (this.SipHeaders != null)
                    hashCode = hashCode * 59 + this.SipHeaders.GetHashCode();
                if (this.Timeout != null)
                    hashCode = hashCode * 59 + this.Timeout.GetHashCode();
                if (this.Disconnect != null)
                    hashCode = hashCode * 59 + this.Disconnect.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
